/*
* Copyright (c) 2012-2016, NVIDIA CORPORATION. All rights reserved.
*
* NVIDIA CORPORATION and its licensors retain all intellectual property
* and proprietary rights in and to this software, related documentation
* and any modifications thereto. Any use, reproduction, disclosure or
* distribution of this software and related documentation without an express
* license agreement from NVIDIA CORPORATION is strictly prohibited.
*/
#pragma once

namespace nvrhi 
{
namespace vulkan
{
// underlying vulkan context
struct VulkanContext
{
    VulkanContext(vk::Instance instance,
                  vk::PhysicalDevice physicalDevice,
                  vk::Device device,
                  vk::AllocationCallbacks *allocationCallbacks = nullptr)
        : instance(instance)
        , physicalDevice(physicalDevice)
        , device(device)
        , allocationCallbacks(allocationCallbacks)
        , pipelineCache(nullptr)
        , defaultDescriptorPool(nullptr)
    { }

    vk::Instance instance;
    vk::PhysicalDevice physicalDevice;
    vk::Device device;
    vk::AllocationCallbacks *allocationCallbacks;
    vk::PipelineCache pipelineCache;

    vk::DescriptorPool defaultDescriptorPool;

    struct {
        bool KHR_maintenance1 = false;
        bool EXT_debug_report = false;
        bool EXT_debug_marker = false;
    } extensions;

    vk::PhysicalDeviceProperties physicalDeviceProperties;
};

} // namespace vulkan
} // namespace nvrhi
